# PanddleX

基于Paddle+Flask的眼部医疗辅助系统, 本项目基于PaddleX提供的FastSCNN语义分割模型，在眼部图像视盘分割数据集上进行训练，并开发了前后端分离项目。

后端代码基于Flask开发，前端WEB界面基于VUE开发。

![](https://ai-studio-static-online.cdn.bcebos.com/936a7f88ceac4085924961e023e0b974e38138def41444dfaf6a58cec091ec4d)

## Develop

### 模型训练


### web部署

```
cd frontend
npm install
npm run build
# npm run serve

cp -r dist/* ../backend/static
cd ..

virtualenv .venv
pip install -r requirements.txt
python app.py
```

### 模型预测

使用模型进行预测，同时使用`pdx.seg.visualize`将结果可视化，可视化结果将保存到`./output/deeplab`下，其中`weight`代表原图的权重，即mask可视化结果与原图权重因子。


```python
import paddlex as pdx
model = pdx.deploy.Predictor('inference_model')
image_name = 'optic_disc_seg/JPEGImages/H0005.jpg'
result = model.predict(image_name)
pdx.seg.visualize(image_name, result, weight=0.4, save_dir='./output/deeplab')
```

    2021-01-23 08:16:45 [INFO]	The visualized result is saved as ./output/deeplab/visualize_H0005.jpg



```python
!zip -r inference_model/ weights.zip
```

    	zip warning: name not matched: weights.zip
    
    zip error: Nothing to do! (try: zip -r inference_model/ . -i weights.zip)



## Reference


## License
